<template>
  <div class="d-md-flex align-items-center justify-content-between flex-wrap p-2 pb-3 contenedorPrincipal">
    <div class="col-5 ms-3 mt-3">
      <label for="solicitante" class="form-label d-block">Solicitante:</label>
      <auto-complete class="d-inline mt-0" v-model="data.solicitante" :elements="solicitantesStore.solicitantes"
        initKey="" placeholder="Apellido/s y Nombre/s" :minLength="3" :disabled="false" id="solicitante" />

      <button type="button" class="d-inline btn btn-principal px-3 ms-3" alt="Ver cupos del solicitante"
        title="Ver cupos del solicitante" @click="validarVerCupos()">
        Ver cupos
      </button>
      <Modal ref="cuposModal" :size="'lg'" :title="cuposTitulo">
        <CuposModal :parametros="cuposParametros"></CuposModal>
      </Modal>
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="becario" class="form-label">Becario:</label>
      <auto-complete v-model="data.becario" :elements="becariosStore.becarios" initKey=""
        placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled="false" id="becario" />
    </div>

    <div class="col-2 ms-3 mt-3">
      <label for="apoderado" class="form-label">Apoderado:</label>
      <auto-complete v-model="data.apoderado" :elements="becariosStore.becarios" initKey=""
        placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled="false" id="apoderado" />
    </div>

    <div class="col-2 ms-3 mt-3">
      <label for="bloque" class="form-label">Bloque Pol&iacute;tico:</label>
      <auto-complete v-model="data.bloque" :elements="bloquesStore.bloques" initKey="" placeholder="Dependencia"
        :minLength="2" :disabled="false" id="bloque" />
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="baproSucursal" class="form-label">Sucursal Bapro:</label>
      <auto-complete v-model="data.baproSucursal" :elements="baproSucursalesStore.getBaproSucursales()" initKey=""
        placeholder="Sucursal" :minLength="2" :disabled="false" id="baproSucursal" />
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="responsable" class="form-label">Responsable:</label>
      <auto-complete v-model="data.responsable" :elements="solicitantesStore.solicYProyectos" initKey=""
        placeholder="Responsable" :minLength="2" :disabled="false" id="responsable" />
    </div>

    <div class="col-2 ms-3 mt-3">
      <label for="f_desde" class="form-label" style="margin-top: 2px !important">Fecha Desde:</label>
      <input required type="date" v-model="data.f_desde" class="form-control" id="f_desde" autocomplete="off" />
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="f_hasta" class="form-label" style="margin-top: 2px !important">Fecha Hasta:</label>
      <input required type="date" v-model="data.f_hasta" class="form-control" id="f_hasta" autocomplete="off" />
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="liquidacion" class="form-label" style="margin-top: 2px !important">Liquidación:</label>
      <auto-complete v-model="data.liquidaciones" :elements="liquidacionesStore.listadoLiquidaciones" initKey=""
        placeholder="liquidación" :minLength="2" :disabled="false" id="liquidaciones" />
    </div>
    <div class="col-2 ms-3 mt-3">
      <label for="orden" class="form-label">Estado:</label>
      <select v-model="data.orden" class="form-select form-select-sm px-4" id="orden">
        <!-- <option :value="null" v-text="'--Seleccione--'"></option> -->
        <option :value="'T'" v-text="'Todos'"></option>
        <option :value="'A'" v-text="'Activo'"></option>
        <option :value="'B'" v-text="'Baja'"></option>
      </select>
    </div>
    <div class="col-9"></div>
    <div class="col-2 ms-3 mt-3 text-end ">
      <button type="button" class="btn btn-principal px-3 mt-2" alt="Buscar Liquidaciones " title="Buscar liquidaciones"
        @click="buscarBecas()">
        <i class="bi bi-search"></i>
      </button>
      <button class="btn btn-principal px-3 mt-2 mx-2" alt="BLimpiar" title="Limpiar" @click="limpiarFormulario()">
        <i class="fs-6 p-2 px-0 fa-solid fa-broom"></i>

      </button>
    </div>
  </div>
  <BoxBecasLiquidadas />
</template>

<script setup lang="ts">
// Librerias
import { DateTime } from "luxon";
import { onMounted, reactive, computed, ref } from "vue";

import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";

//import type { PropType } from "vue";
import { loading, isEmpty } from "@/shared.js";
import { AutoComplete, Modal } from "@hcd-bsas/vue3-components";

// Componentes
import BoxBecasLiquidadas from "@/components/Liquidaciones/BoxBecasLiquidadas.vue";
import CuposModal from "@/components/becas/actualizacion/cupos/Modal.vue";

// Entidades
import Solicitante from "@/entities/Solicitante";
import type Becario from "@/entities/becas/Becario";
import type Bloque from "@/entities/Bloque";
import type BaproSucursal from "@/entities/becas/BaproSucursal";
import type Liquidacion from "@/entities/Liquidaciones/Liquidacion";

// Stores
import { useSolicitantesStore } from "@/stores/solicitantes";
import { useLiqBecasCabeceraStore } from "@/stores/Liquidaciones/cabeceraBecas";
import { useBecariosStore } from "@/stores/becas/becarios";
import { useBloquesStore } from "@/stores/bloques";
import { useBaproSucursalesStore } from "@/stores/becas/baproSucursales";
import { useLiquidacionesStore } from "@/stores/Liquidaciones/liquidaciones";


const props = defineProps({
  tipoConsulta: { type: String }
});

const solicitantesStore = useSolicitantesStore();
const liqBecasCabeceraStore = useLiqBecasCabeceraStore();
const becariosStore = useBecariosStore();
const bloquesStore = useBloquesStore();
const baproSucursalesStore = useBaproSucursalesStore();
const liquidacionesStore = useLiquidacionesStore();

const emits = defineEmits(["cerrar"]);

var data = reactive({
  solicitante: null as Solicitante | null,
  f_desde: null as String | null,
  f_hasta: null as String | null,
  becario: undefined as Becario | undefined,
  apoderado: undefined as Becario | undefined,
  bloque: undefined as Bloque | undefined,
  baproSucursal: undefined as BaproSucursal | undefined,
  responsable: undefined as Solicitante | undefined,
  liquidaciones: undefined as Liquidacion | undefined,
  orden: 'T' as String | null,


});

const fechaMostrar = (fecha: string | null) =>
  fecha !== null ? DateTime.fromISO(fecha).toFormat("dd/MM/yyyy") : "";
const valFDesde = computed(() => !isEmpty(data.f_desde));
const valFHasta = computed(() => !isEmpty(data.f_hasta));
const valSolicitante = computed(() => !isEmpty(data.solicitante));

const cuposTitulo = computed(
  () =>
    'Cupos del solicitante "' +
    data.solicitante?.ayn +
    '"' +
    " desde el " +
    fechaMostrar(String(data.f_desde)) +
    " hasta el " +
    fechaMostrar(String(data.f_hasta))
);

const cuposParametros = computed(() => ({
  f_cupo_des: data.f_desde,
  f_cupo_has: data.f_hasta,
  id_tabla_sol: data.solicitante?.id_tabla_sol,
  usar_perfil_consulta: 0,
}));

const cuposModal = ref(Modal);

onMounted(async () => {
  loading.show();
  await cargar();
  loading.hide();
});

function validarVerCupos() {

  const swal: SweetAlertOptions<any, any> = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (!valFDesde.value) {
    swal.html = 'Por favor, complete el campo "Fecha Desde".';
  } else if (!valFHasta.value) {
    swal.html = 'Por favor, complete el campo "Fecha Hasta".';
  } else if (!valSolicitante.value) {
    swal.html = 'Por favor, complete el campo "Solicitante".';
  }
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  verCupos();
}

function verCupos() {
  cuposModal.value?.show();
}

function limpiarFormulario() {
  const fechaActual = new Date();
  const anioActual = fechaActual.getFullYear();

  data.f_desde = anioActual + "-03-01";
  data.f_hasta = anioActual + "-12-31";

  data.bloque = '';
  data.solicitante = '';
  data.f_desde = '';
  data.f_hasta = '';
  data.becario = '';
  data.apoderado = '';
  data.baproSucursal = '';
  data.responsable = '';

}

async function cargar() {

  const fechaActual = new Date();
  const anioActual = fechaActual.getFullYear();

  data.f_desde = anioActual + '-03-01';
  data.f_hasta = anioActual + '-12-31';

  await Promise.all([
    solicitantesStore.fetchSolicYProyectos(),
    becariosStore.fetchBecarios(),
    bloquesStore.fetchBloques(),
    baproSucursalesStore.fetchBaproSucursales(),
    liquidacionesStore.updateListadoLiquidaciones()
  ])


}

async function validoCampos() {

  const swal2: SweetAlertOptions<any, any> = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (!valFDesde.value) {
    swal2.html = 'Por favor, complete el campo "Fecha Desde". ';
    Swal.fire(swal2);
    return false;
  }
  if (!valFHasta.value) {
    swal2.html = 'Por favor, complete el campo "Fecha Hasta". ';
    Swal.fire(swal2);
    return false;
  }
  if (data.becario?.id_becario == null || data.becario?.id_becario == undefined) {
    swal2.html = 'Por favor, complete el campo "Becario".';
    Swal.fire(swal2);
    return false;
  }
  return true;

}
async function buscarBecas() {


  let busquedaOK = true as Boolean | undefined;
  if (props.tipoConsulta == 'Anular') {
    busquedaOK = await validoCampos();
  }
  if (busquedaOK) {
    // SI ES TRUE BUSCA
    const paramsRequest: Object = {
      f_desde: data.f_desde,  //'01-01-2023',
      f_hasta: data.f_hasta,  //'01-06-2023',
      id_liq_resu: null,
      id_tabla_sol: data.solicitante?.id_tabla_sol,
      id_beca: null,
      id_becario: data.becario?.id_becario,
      id_apoderado: data.apoderado?.id_becario,
      id_dependen: data.bloque?.id_dependen,
      baprosuc: data.baproSucursal?.c_bapro,
      id_responsable: data.responsable?.id_solicitante,
      orden: data.orden,
      //FALTA ID_RESPONSABLE
    };
    loading.show();
    await liqBecasCabeceraStore.getListadoConsultaLiquidacion(paramsRequest);
    loading.hide();
  }

}
function cerrar() {
  emits("cerrar");
}



//const tipoConsulta = computed(() => props.tipoConsulta?.trim());
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
